
extern double sign(double d);
extern double * poly_root_2(double a,double b,double c);
extern double * poly_root_3(double a,double b,double c,double d);
extern double * poly_root_4(double a,double b,double c,double d,double e);
extern void set_attitude(configPt q,lm_quadspline_str *quadspline_paramPt);
extern p3d_quadspline_data *p3d_alloc_spec_quadspline_localpath (p3d_rob *robotPt, configPt q_i, configPt q_f);
extern p3d_localpath *p3d_alloc_quadspline_localpath(p3d_rob *robotPt, configPt q_i, configPt q_f, int lp_id,int is_valid);
extern double p3d_quadspline_dist(p3d_rob *robotPt, p3d_localpath *localpathPt);
extern configPt p3d_quadspline_config_at_param(p3d_rob *robotPt, p3d_localpath *localpathPt, double param);
extern p3d_localpath *p3d_extract_quadspline(p3d_rob *robotPt, p3d_localpath *localpathPt, double t1, double t2);
extern lm_quadspline_str *lm_get_quadspline_lm_param(p3d_rob* robotPt);
extern lm_quadspline_str *lm_create_quadspline(p3d_rob *robotPt, double *dtab, int *itab);
extern int p3d_create_quadspline_local_method(char *name,double *dtab, int *itab);
extern void p3d_destroy_quadspline_data(p3d_rob* robotPt, p3d_quadspline_data* quadspline_dataPt);
extern void p3d_quadspline_destroy(p3d_rob* robotPt, p3d_localpath* localpathPt);
extern p3d_localpath *p3d_copy_quadspline_localpath(p3d_rob* robotPt, p3d_localpath* localpathPt);
extern double p3d_quadspline_cost(p3d_rob *robotPt, p3d_localpath *localpathPt);
extern p3d_localpath *p3d_simplify_quadspline(p3d_rob *robotPt, p3d_localpath *localpathPt, int *need_colcheck);
extern int p3d_write_quadspline(FILE *file, p3d_rob* robotPt, p3d_localpath* localpathPt);
extern double p3d_quadspline_stay_within_dist(p3d_rob* robotPt, p3d_localpath* localpathPt, double parameter, whichway dir, double *distances);
extern p3d_localpath *p3d_quadspline_localplanner (p3d_rob *robotPt, configPt qi, configPt qf, int * ikSol);
extern void print_quadspline(p3d_rob *robotPt,p3d_localpath *localpathPt);
extern void print_lin(p3d_rob *robotPt,p3d_localpath *localpathPt);
extern void p3d_switch_to_quad(p3d_rob* robotPt,p3d_traj* traj);
extern void p3d_switch_to_quad_from_FF(p3d_rob* robotPt,p3d_traj* traj);
extern void p3d_switch_to_lin(p3d_rob* robotPt,p3d_traj* traj);
extern void unit_test(p3d_rob* robotPt,int nbtest);
